% 
% @(#)Condition.m	1.1  3/6/87
%
export _ConditionObject to "Builtins"

const _ConditionObject == immutable object _ConditionObject
  % Conditions implement Hoare style condition semantics, with the following
  % exceptions:
  %     1.  There is no urgent queue, signalers are placed at the head of 
  %         the monitor entry queue, and thus successive signals are 
  %         rescheduled in LIFO order.
  export create, getSignature
  const ConditionType == type ConditionType
  end ConditionType
  function getSignature -> [result : Signature]
    result <- ConditionType
  end getSignature
  operation create -> [result : ConditionType]
    result <- object aCondition
    end aCondition
  end create
end _ConditionObject
